package xyz.twovb.sgm.commands.impl;

/*
 * Created by 2vb - 2/7/2024
 */

import dev.rollczi.litecommands.annotations.argument.Arg;
import dev.rollczi.litecommands.annotations.command.Command;
import dev.rollczi.litecommands.annotations.context.Context;
import dev.rollczi.litecommands.annotations.execute.Execute;
import dev.rollczi.litecommands.annotations.permission.Permission;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import xyz.twovb.sgm.SGM;
import xyz.twovb.sgm.games.Minigame;
import xyz.twovb.sgm.games.impl.capturethebrick.guis.TeamGui;
import xyz.twovb.sgm.guis.InitGameGui;
import xyz.twovb.sgm.guis.JoinGameGui;
import xyz.twovb.toolbox.api.CustomPlayer;
import xyz.twovb.toolbox.utils.ChatUtils;

import java.util.Optional;
import java.util.UUID;

@Command(name = "game")
public class GameCommand {

    @Execute()
    void execute(@Context CommandSender sender) {
        StringBuilder builder = new StringBuilder();
        builder.insert(0, "&7Enabled games:");
        builder.append("\n");
        for (int i = 0; i < SGM.getInstance().getGameManager().getRegisteredGames().size(); i++) {
            String game = SGM.getInstance().getGameManager().getRegisteredGames().get(i);
            builder.append(game);
            if (i < SGM.getInstance().getGameManager().getRegisteredGames().size() - 1) {
                builder.append(", ");
            }
        }
        sender.sendMessage(ChatUtils.translate(builder.toString()));
    }

    @Execute(name = "init")
    @Permission("sgm.games.init")
    void init(@Context Player player, @Arg("name") Optional<String> map) {
        new InitGameGui().getGui().show(player);
    }

    @Execute(name = "start")
    @Permission("sgm.games.start")
    void start(@Context Player player) {
        Minigame game = SGM.getInstance().getGameManager().findGame(player);
        if (game == null) {
            CustomPlayer cPlayer = new CustomPlayer(player);
            cPlayer.sendMessage(SGM.getInstance().getMessages().getString("sgm.game.not-found"));
        } else {
            game.start(player);
        }
    }

    @Execute(name = "team")
    @Permission("sgm.games.team")
    void teamJoin(@Context Player player, @Arg("player") Optional<Player> target) {
        Player targetPlayer = target.orElse(player);
        new TeamGui(targetPlayer).getGui().show(player);
    }

    @Execute(name = "join")
    void join(@Context Player player) {
        new JoinGameGui().getGui().show(player);
    }

    @Execute(name = "addplayer")
    void testjoin(@Context CommandSender sender, @Arg("player") Player target, @Arg("id") String id) {
        SGM.getInstance().getGameManager().addPlayerToGame(target, UUID.fromString(id));
    }

}
