package xyz.twovb.sgm.games.impl.capturethebrick.events;
/*
 * Created by 2vb - 7/7/2024
 */

import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

public class PlayerGameInteractionEvent extends Event implements Cancellable {

    private static final HandlerList HANDLER_LIST = new HandlerList();
    private final Player interacted;
    private final Player interacter;
    private boolean isCancelled;

    public PlayerGameInteractionEvent(Player interacted, Player interacter) {
        this.interacted = interacted;
        this.interacter = interacter;
        this.isCancelled = false;
    }

    public static HandlerList getHandlerList() {
        return HANDLER_LIST;
    }

    public Player getInteracted() {
        return this.interacted;
    }

    public Player getInteracter() {
        return this.interacter;
    }

    @Override
    public HandlerList getHandlers() {
        return HANDLER_LIST;
    }

    @Override
    public boolean isCancelled() {
        return this.isCancelled;
    }

    @Override
    public void setCancelled(boolean cancelled) {
        this.isCancelled = cancelled;
    }

}

